/*=========================================================================*\
* Benchmarking functions
* Diego Nehab
* 9/9/2000
\*=========================================================================*/

#ifndef _BENCH_H_
#define _BENCH_H_

/*=========================================================================*\
* Exported function declarations
\*=========================================================================*/
/*-------------------------------------------------------------------------*\
* Initializes the module
\*-------------------------------------------------------------------------*/
void bench_open(void);

/*-------------------------------------------------------------------------*\
* Marks current time.
* Returns
*   timer mark.
\*-------------------------------------------------------------------------*/
int bench_mark(void);

/*-------------------------------------------------------------------------*\
* Prinst the same string repeatedly
* Input
*   mark: timer mark
* Returns
*   number of seconds elapsed since last mark on timer, -1 in case of error
\*-------------------------------------------------------------------------*/
double bench_gettime(int mark);

/*-------------------------------------------------------------------------*\
* Frees all resources used by module
\*-------------------------------------------------------------------------*/
void bench_close(void);

#endif /* _BENCH_H_ */
