/*=========================================================================*\
* 3D Group (Danilo, Diego, Diogo)
* 11/11/2000
\*=========================================================================*/

#include <stdio.h>

#ifdef GUI
#include <iup.h>
static Ihandle *g = NULL;
#endif

static float pos = 0;
static float max = 100;
static float dx = 0;

/*-------------------------------------------------------------------------*\
* Open package
\*-------------------------------------------------------------------------*/
#ifdef GUI
void gauge_open(Ihandle *gauge)
{
	g = gauge;
}
#else
void gauge_open(void)
{
}
#endif

/*-------------------------------------------------------------------------*\
* Reset counter.
\*-------------------------------------------------------------------------*/
void gauge_start(void)
{
	pos = 0;
}

/*-------------------------------------------------------------------------*\
* End counting.
\*-------------------------------------------------------------------------*/
void gauge_end(void)
{
	printf("\r100%%\n");
#ifdef GUI
	if (g) 
		IupSetfAttribute(g, IUP_VALUE, "%f", 1);
#endif
}

/*-------------------------------------------------------------------------*\
* Set 100% mark.
\*-------------------------------------------------------------------------*/
void gauge_setmax(int umax)
{
	max = (float)umax;
}

/*-------------------------------------------------------------------------*\
* Advances counter.
\*-------------------------------------------------------------------------*/
int gauge_increase(int udx)
{
	pos += udx;
	dx = (float)udx;
	if (pos > max) {
		pos = max;
		return 0;
	}
	return 1;
}

/*-------------------------------------------------------------------------*\
* Prints current gauge position.
\*-------------------------------------------------------------------------*/
void gauge_print(void)
{
	int perc = (int)(100*(pos - dx)/max);

	if (perc < (int)(100*pos/max)) {
		printf("\r%d%%", perc);
		fflush(stdout);
#ifdef GUI
		if (g) 
			IupSetfAttribute(g, IUP_VALUE, "%f", (float)(perc)/100);
#endif
		dx = 0;
	}
}
