/*------------------------------------------------------------------*\
* Linked list implementation
* 3D group (Danilo, Diego and Diogo)
\*------------------------------------------------------------------*/

#include "image.h"

/*------------------------------------------------------------------*\
* Tipos de dados usados.                                                    *
\*------------------------------------------------------------------*/
typedef struct t_list *p_list;
typedef int (*p_listcallback) (int xc, int yc, int w, int l, float theta, uchar *rgb, int level);

/*------------------------------------------------------------------*\
* Cria uma nova lista
\*------------------------------------------------------------------*/
p_list list_create(void);

/*------------------------------------------------------------------*\
* Enumera os elementos da lista
\*------------------------------------------------------------------*/
p_list list_enum(p_list p, int *xc, int *yc, int *w, int *l, float *theta, uchar *rgb, int *level);

/*------------------------------------------------------------------*\
* Insere um elemento no inicio da lista. 
\*------------------------------------------------------------------*/
void list_prepend(p_list *h, int xc, int yc, float w, float l, float theta, uchar *rgb, int level);

/*------------------------------------------------------------------*\
* Ordena a lista pelo metodo merge sort.
\*------------------------------------------------------------------*/
void list_mergesort(p_list *h);

/*------------------------------------------------------------------*\
* Libera a memoria ocupada pela lista.
\*------------------------------------------------------------------*/
void list_kill(p_list *h);

/*------------------------------------------------------------------*\
* Imprime a lista
\*------------------------------------------------------------------*/
void list_print(p_list p);
